NB. picmake - creates database and imports pictures from folder

require 'files strings ~addons/sqlite/sqlite.ijs'

fext=: ]

DIR=: jpath '~addons/sqlite_pic/'
DBFILE=: DIR,'nature.sqlite'

ddl=: 0 : 0
  create table PIC (
    PICNAME   varchar(128) not null primary key,
    PICTYPE   varchar(8) not null,
    PICSIZE   integer not null,
    THUMBTYPE varchar(8),
    PICVAL    blob, 
    THUMBVAL  blob );
)

sqlIns=: 0 : 0
  insert into pic values (?,?,?,?,?,?);
)

make=: 3 : 0
  pics=. {."1] 1!:0 DIR,'*.jpg'
  pnames=. (_4&}.)&.> pics
  ptypes=. (#pics)#<'jpeg'
  ttypes=. (#pics)#<'png'
  pvals=. (<DIR) fread@,&.> pics
  tvals=. (<DIR) fread@,&.> pnames ,&.> <'.png'
  psz=. #&.>pvals

  ferase DBFILE

  ]db=: 'psqlite'conew~ DBFILE
  exec__db ddl
  (pnames,.ptypes,.psz,.ttypes,.pvals,.tvals) apply__db sqlIns;0 0 0 0 1 1
  smoutput colquery__db 'select PICNAME, PICTYPE, PICSIZE from PIC;'
  destroy__db''
)
