-- This script defines tables for Phrase DB demo

create table GROUPS (
  GID integer not null primary key,
  GNAME varchar(64) not null
);

create table SECTION (
  SID varchar(16) not null primary key,
  GID integer not null references GROUPS(GID) on delete restrict,
  SLETTER varchar(8) not null,
  SNAME varchar(64) not null,
  unique (GID, SLETTER)
);

create table PHRASE (
  PID integer not null primary key,
  SID varchar(16) not null references SECTION(SID) on delete restrict,
  POS integer not null,
  PHRASE varchar(128),
  COMMENT varchar(128)
);

