NB. phrdb - phrase data access layer

require '~addons/sqlite/sqlite.ijs'

coclass 'pphrdb'

ConStr=: jpath '~CGI/phrasedb/phrases.sqlite'

NB. =========================================================
lasterr=: [: deb LF -.~ }.@(13!:12)
phrdberr_z_=: (assert 0=#) f.

sBegin=: 0 : 0
  r=. 0 0$''
  msg=. ''
  try.
    db=. ConStr conew 'psqlite'
)
sEnd=: 0 : 0
  catch. msg=. lasterr'' end.
  if. 0=nc<'db' do. destroy__db '' end.
  phrdberr msg
  r
)
sdefine=: 1 : 'm : (sBegin , (0 : 0) , sEnd)'

NB. =========================================================
sqlGroups=: 0 : 0
  select GID,GNAME from GROUPS order by GID;
)
getGroups=: verb sdefine
    r=. query__db sqlGroups
)

sqlSecByGroup=: 0 : 0
  select SID,SNAME from SECTION where GID=? order by SLETTER;
)
getSecsByGroup=: verb sdefine
    r=. y query__db sqlSecByGroup
)

sqlPhrasesBySec=: 0 : 0
  select PHRASE,COMMENT from PHRASE where SID=? order by POS;
)
getPhrasesBySec=: verb sdefine
    r=. (boxopen y) query__db sqlPhrasesBySec
)

sqlPhrasesByStr=: 0 : 0
  select P.SID,G.GNAME,S.SNAME,P.PHRASE,P.COMMENT
    from GROUPS G,SECTION S,PHRASE P
   where G.GID=S.GID and S.SID = P.SID
     and (P.PHRASE like ?1 or P.COMMENT like ?1)
   order by S.GID,S.SLETTER,P.POS;
)
findPhrasesByStr=: dyad sdefine
    limit__db x
    r=. (<'%',y,'%') query__db sqlPhrasesByStr
)

NB. =========================================================
0 : 0
  getGroups_pphrdb_''
  getSecsByGroup_pphrdb_ 1
  getPhrasesBySec_pphrdb_ '1C'
  0 10 findPhrasesByStr_pphrdb_ '%test%'
)
