NB. phrmake - creates database and imports phrase scripts

require '~addons/sqlite/sqlite.ijs files regex'

DDB=: jpath '~user/phrasedb/'
FDB=: DDB,'phrases.sqlite'

DPH=: jpath '~system/examples/phrases/'

make=: 3 : 0
  ferase FDB
  db=. 'psqlite' conew~ FDB
  err=. ''
  try.
    exec__db fread DDB,'phrases_ddl.sql'
    exec__db fread DDB,'phrases_data.sql'
  catch. err=. 13!:12'' end.
  destroy__db''
  err
)

sqlInsSection=: 'insert into SECTION values (?,?,?,?)'

sqlInsPhrase=: 0 : 0
 insert into PHRASE
   (SID,POS,PHRASE,COMMENT)
   values (?,?,?,?)
)

NB. 11 sec
import=: 3 : 0
  PHR=. 3&}.&.>_4&}.&.> {."1(1!:0) DPH,'*.ijs'
  PHR=. PHR /: (".@}.;{.)&> PHR
  db=. 'psqlite' conew~ FDB
  for_p. PHR do.
    'gr let'=. (".@}. ; toupper@{.)>p
    sid=. (":gr),toupper let
    err=. sid
    try.
      phr=. dltb&.> readfile p
      err=. err,' ',sname
      err=. err,' ',":(sid;gr;let;sname) apply__db sqlInsSection
      if. #phr do.
        err=. err,' ',":((<sid),.(<"0] 10*1+i.#phr),.phr) apply__db sqlInsPhrase
      end.
      err=. err,' OK'
    catch.
      err=. err,' ',({.~ i.&LF) 13!:12''
    end.
    smoutput err
  end.
  destroy__db''
)

NB. 0.7 sec
import2=: 3 : 0
  PHR=. 3&}.&.>_4&}.&.> {."1(1!:0) DPH,'*.ijs'
  PHR=. PHR /: (".@}.;{.)&> PHR
  secs=. i.0 0
  phrs=. i.0 0
  for_p. PHR do.
    'gr let'=. (".@}. ; toupper@{.)>p
    sid=. (":gr),toupper let
    phr=. dltb&.> readfile p
    secs=. secs,(sid;gr;let;sname)
    phrs=. phrs,((<sid),.(<"0] 10*1+i.#phr),.phr)
  end.
  err=. ''
  db=. 'psqlite' conew~ FDB
  try.
    secs apply__db sqlInsSection
    phrs apply__db sqlInsPhrase
  catch. err=. ({.~ i.&LF) 13!:12'' end.
  destroy__db''
  err
)

readfile=: 3 : 0
  ptxt=. toJ fread DPH,'phr','.ijs',~>y
  lines=. LF cut ptxt
  sname=: (}.~ >:@i.&' ') 22}. >{. lines
  lines=. }. lines
  if. 0= #lines do. 0 2$'' return. end.
  (({. ; 4&}.@}.)~ 'NB.'&(E.i.1:))&> lines
)

0 : 0
  make ''
  6!:2 'import 0'
  6!:2 'import2 0'  NB. atlernative
)
