NB. phrview - phrase presentation layer

require '~addons/jhp/jhp.ijs'

coclass 'pphrview'

LISTSIZE=: 8

selected=: (''"_)`('selected="1"'"_)@.-:

NB. =========================================================
splitSid=: }: , '.' , {:

listGroups=: dyad hdefine
<select name="group" size="<%=LISTSIZE%>" onchange="sel('group')">
  <% for_g. }.y do. 'gid gname'=. g %>
    <option <%=x selected gid %> value="<%= gid %>">
      <%= gid %>. <%=HTMLEncode gname %></option>
  <% end.%>
</select>
)

listSections=: dyad hdefine
<select name="section" size="<%=LISTSIZE%>" onchange="sel('section')">
  <% for_s. }.y do. 'sid sname'=. s %>
    <option <%=x selected sid %> value="<%= sid %>">
      <%= splitSid sid %> <%=HTMLEncode sname %></option>
  <% end.%>
</select>
)

tabPhrases=: verb hdefine
<table>
  <% for_p. }.y do. 'phrase comment'=. p %>
    <tr>
      <td><code><%=HTMLEncode phrase %></code></td>
      <td style="color:green">NB. <%=HTMLEncode comment %></td>
    </tr>
  <% end.%>
</table>
)

HESC=: cut'\ \\ ( \( ) \) [ \[ ] \] { \{ } \} | \| * \* ? \? . \. + \+ % .* _ .'
hilite=: (4 : 0)&HTMLEncode
  ('(?i)',x rplc HESC) ([:'<b>'&, ,&'</b>') rxapply y
)

foundPhrases=: dyad hdefine
<table>
  <% last=. ''
     for_p. }.y do. 'sid gname sname phrase comment'=. p 
       if. -. sid-:last do. %>
    <tr>
      <td colspan="3" style="border-top: 1px solid lightgrey">
        <%=splitSid sid%> <%=gname%> -
	<a href="#" onclick="sec('<%=sid%>')"><%= sname %></a></td>
    </tr>
    <% end. %>
    <tr>
      <td><code><%=x hilite phrase %></code></td>
      <td style="color:green">NB. <%= x hilite comment %></td>
    </tr>
  <%   last=. sid
     end.%>
</table>
)

viewSearch=: 0&$: : (dyad hdefine)
<span>Search for 
  <%= x#'<div>'%>
  <input name="search" value="<%= y %>" size="16"
    onkeypress="if (event.keyCode==13) {find();return false;}">
  <%= x#'</div><div style="float:right;clear:both;">'%>
    <input type="button" value="Go" onclick="find()">
  <%= x#'</div>'%>
</span>
)

NB. =========================================================
0 : 0
  require'~CGI/phrasedb/phrdb.ijs'
  1 listGroups_pphrview_ getGroups_pphrdb_'' 
  '1C' listSections_pphrview_ getSecsByGroup_pphrdb_ 1 
  tabPhrases_pphrview_ getPhrasesBySec_pphrdb_ '1C'
)
