NB. JHP - JHP: Hypertext Processor
NB. 25-Nov-05 Oleg Kobchenko
NB. 08-Jul-06 Oleg Kobchenko - j601
NB. 16-Sep-06 Oleg Kobchenko - Expires, ~CGI folder, OpenGL
NB. 20-Sep-06 Oleg Kobchenko - stdout fallback

require 'regex files'

coclass 'z'

stdout_z_=: 1!:2&4
stderr_z_=: 1!:2&5
padj=: }:@,@:(,&LF"1)^:(1: < #@$)@":
print_z_=: 0 0&$@stdout@padj_pjhp_ NB. smoutput NB. 0 0&$@(1!:2&4)
println_z_=: [: print [: LF"_ print

hecho=: ('<%=';'<%print ')&stringreplace
pathdir=: {.~ >:@{:@I.@(e.&'/\')

cutmatch=: ] rxcut~ rxmatches         NB. cut matches, no sub-matches
altcut=: _2&(]\)@cutmatch             NB. 2 column alternating cut
hcut=: '<%(?:[^%]|%[^>])+%>'&altcut   NB. hypertext cut
hecut=: [: 2&{."1 [: hcut hecho

hasnl=: CRLF&(+./@:e.)
lastnl=: e.&CRLF@{:
lrep=: 3 : '5!:5<''y'''
lecho=: ('print '&,)@lrep
lnecho=: ([: 'println '&, ,&LF)@lrep
mecho=: [: ; [: (lnecho&.>@}: , lecho&.>@{:) [: <;._2 ,&LF
necho=: [: ; <@lnecho;._2
techo=: (lecho`(mecho`necho@.lastnl)@.hasnl)`]@.(''&-:)
ctrim=: [: _2&}. 2&}.
adj=: ((techo`ctrim)"_) 128!:2&.>&.|: hecut
flat=: [: ; [: ,&LF^:(LF~:{:)&.> a: -.~ ,
hrep=: flat@adj
hfmt=: ('3 : 0]0',LF)"_ , hrep , (')',LF)"_
pfmt=: '<%' -: 2&{.
hrun=: [: 0!:0 hfmt^:pfmt
frun=: hrun @ toJ @ fread

hdefine=: 1 : 'm : (hrep 0 : 0)'
hdef=:    2 : 'm : (hrep n)'

ndx_1=: #@[ _1:^:= i.
unescch=: [: {&a. [: 0&". '16b'"_ , tolower@}.
unpercent=: '%..'&((unescch :: ]) rxapply)
unplus=: (' ',a.) {~ ('+',a.)&i.
unescape=: unpercent@unplus
eqsplit=: ({.~ ; (}.~ >:)) i.&'='
qssplit=: empty`([: eqsplit;._2 ,&'&')@.(2=3!:0 *. 0<#)
qsparse=: [: unescape&.> qssplit

qkeys=: 3 : 0
  if. 0~:nc<'CGIKEYS' do.
    'CGIKEYS CGIVALS'=: a:"_`(<"1@|:)@.(0<#) qsparse 2!:5 'QUERY_STRING'
  end.
  CGIKEYS
)

qparam=: ''&$: : (4 : 0)
  if. 0 > i=. (qkeys'') ndx_1 boxopen y do. x return. end.
  v=. i{::CGIVALS
  if. 1 4 8 16 64 128 e.~ 16bff (17 b.) 3!:0 x do.
    ($x)$(0".v),,x
  end.
)

jhperr=: 3 : 0
  ContentType 'text/plain'
  jhpalert y
  stderr y,LF
)

jhpalert=: 3 : 0
  println '<pre>'
  println y
  println '</pre>'
)

jhpdump=: 3 : 0
  print '<pre>'
  print HTMLEncode toJ fread y
  print '</pre>',LF
  if. 'jhp'-: _3{.y do.
    if. pfmt s=. toJ fread y do.
      print '<p>Code</p>',LF,'<pre>'
      print HTMLEncode hfmt toJ fread y
      println '</pre>'
    else.
      println 'Run as is'
    end.
  end.
)

NB. user functions

ContentType=: 3 : 0
  if. 0 <: nc<'ContentTypeSet_j_' do. return. end.
  ContentTypeSet_j_=: y
  println 'Content-Type: ',y,LF
)

Expires=: 3 : 0
  println 'Expires: ',":y
)

HTMLEncode=: ('&';'&amp;';'<';'&lt;';'>';'&gt;')&stringreplace

3 : 0^:]IFWIN32
  GetStdHandle_j_=: 'kernel32 GetStdHandle > i   i'&(15!:0)
  WriteFile_j_=:    'kernel32 WriteFile    > i   i *c i *i i'&(15!:0)
  stdout_z_=: [: WriteFile_j_ (GetStdHandle_j_ _11) ; , ; # ; ,@2: ; 0:
  load '~addons/jhp/winbmp.ijs'
)

3 : 0^:-.IFCONSOLE
  print_z_=: smoutput
  println_z_=: smoutput
  i.0 0
)
